;; 
;    include \masm32\include\masm32rt.inc

.686P
.MMX
.XMM
.MODEL flat, stdcall
.STACK 4096

OPTION SCOPED
OPTION LJMP
OPTION CASEMAP:NONE


;
; inc files
;
INCLUDE \Masm32\INCLUDE\windows.inc
INCLUDE \Masm32\INCLUDE\kernel32.inc
INCLUDE \Masm32\INCLUDE\masm32.inc
INCLUDE \Masm32\INCLUDE\user32.inc


;
; lib files
;
INCLUDELIB \Masm32\LIB\kernel32.lib
INCLUDELIB \Masm32\LIB\user32.lib
INCLUDELIB \Masm32\LIB\masm32.lib

INCLUDE \Masm32\MACROS\macros.asm


    vector struct
      x REAL4 ?
      y REAL4 ?
      z REAL4 ?
      w REAL4 ?
    vector ends

; 
    .data
align 16
      v1    vector  <1.0,2.0,3.0>
      vr    vector  <>
      dblx  REAL8   0.0
      dbly  REAL8   0.0
      dblz  REAL8   0.0
    .code
; 


align 16
;
Vector3D_Normalize_FPU PROC ptrVR:DWORD, ptrV1:DWORD

  mov esi,ptrV1
  mov edi,ptrVR

  fld dword ptr [esi]
  fmul st,st(0)
  fld dword ptr [esi+4]
  fmul st,st(0)
  faddp st(1),st
  fld dword ptr [esi+8]
  fmul st,st(0)
  faddp st(1),st
  fsqrt
  fld dword ptr [esi]
  fdiv st,st(1)
  fstp dword ptr [edi]
  fld dword ptr [esi+4]
  fdiv st,st(1)
  fstp dword ptr [edi+4]
  fld dword ptr [esi+8]
  fdiv st,st(1)
  fstp dword ptr [edi+8]

  ret

Vector3D_Normalize_FPU ENDP
; 


align 16
;
normalize proc pv1:DWORD, pvr:DWORD

    mov ecx, pv1
    mov edx, pvr
    fld [ecx].vector.z
    fmul [ecx].vector.z
    fld [ecx].vector.y
    fmul [ecx].vector.y
    faddp st(1), st
    fld [ecx].vector.x
    fmul [ecx].vector.x
    faddp st(1), st
    fsqrt
    fld4 1.0
    fdivr
    fld [ecx].vector.x
    fmul st, st(1)
    fstp [edx].vector.x
    fld [ecx].vector.y
    fmul st, st(1)
    fstp [edx].vector.y
    fmul [ecx].vector.z
    fstp [edx].vector.z
    ret

normalize endp
; 


align 16
;
Normalize_Sse2 proc pv1:DWORD, pvr:DWORD
	mov ecx, pv1
	mov edx, pvr
		movaps XMM0,OWORD PTR [ecx]						;; XMM0 = W,Z,Y,X
		movaps XMM2,XMM0								;; XMM2 = W,Z,Y,X
		mulps XMM0,XMM0								;; XMM0 = W^2,Z^2,Y^2,X^2
		pshufd XMM1,XMM0,04Eh							;; XMM1 = Y^2,X^2,W^2,Z^2
		addps XMM1,XMM0								;; XMM1 = W^2+Y^2,Z^2+X^2,Y^2+W^2,X^2+Z^2
		pshufd XMM0,XMM1,0B1h							;; XMM0 = Z^2+X^2,W^2+Y^2,X^2+Z^2,Y^2+W^2
		addps XMM0,XMM1								;; XMM0 = Z^2+X^2+W^2+Y^2,W^2+Y^2+Z^2+X^2,X^2+Z^2+Y^2+W^2,Y^2+W^2+X^2+Z^2
		rsqrtps XMM0,XMM0								;; XMM0 = 1/(X^2+Y^2+Z^2+W^2),1/(X^2+Y^2+Z^2+W^2),1/(X^2+Y^2+Z^2+W^2),1/(X^2+Y^2+Z^2+W^2)
		mulps XMM0,XMM2								;; XMM0 = W*1/(X^2+Y^2+Z^2+W^2),Z*1/(X^2+Y^2+Z^2+W^2),Y*1/(X^2+Y^2+Z^2+W^2),X*1/(X^2+Y^2+Z^2+W^2)
		movaps OWORD PTR [edx],XMM0						;; XMM0 = W/(X^2+Y^2+Z^2+W^2),Z/(X^2+Y^2+Z^2+W^2),Y/(X^2+Y^2+Z^2+W^2),X/(X^2+Y^2+Z^2+W^2)
	ret
Normalize_Sse2 endp
; 


start:
; 
    invoke normalize, ADDR v1, ADDR vr

    fld vr.x
    fstp dblx
    fld vr.y
    fstp dbly
    fld vr.z
    fstp dblz

    invoke crt_printf, chr$("%f  %f  %f %c"), dblx, dbly, dblz, 10

    mov ebx, 10000000
    invoke GetTickCount
    push eax
    .WHILE ebx
      invoke Vector3D_Normalize_FPU, ADDR vr, ADDR v1
      dec ebx
    .ENDW
    invoke GetTickCount
    pop edx
    sub eax, edx
    print ustr$(eax),13,10

    mov ebx, 10000000
    invoke GetTickCount
    push eax
    .WHILE ebx
      invoke normalize, ADDR v1, ADDR vr
      dec ebx
    .ENDW
    invoke GetTickCount
    pop edx
    sub eax, edx
    print ustr$(eax),13,10

    mov ebx, 10000000
    invoke GetTickCount
    push eax
    .WHILE ebx
      invoke Normalize_Sse2, ADDR v1, ADDR vr
      dec ebx
    .ENDW
    invoke GetTickCount
    pop edx
    sub eax, edx
    print ustr$(eax),13,10

;    inkey "Press any key to exit..."
		invoke Sleep,1000
		mov eax,input(13,10,13,10," Press ENTER to quit...")

;    exit
		Invoke ExitProcess,0

; 
end start
